function [ Gn,Bn,Fn ] = G_generator( N )
%Gn: Encode matrix
%Bn : Bit-reversal Matrix
%Fn: Kernel Matrix
tic;
F=[1,0;1,1];
Fn=[1,0;1,1];
I=[1,0;0,1];
Bn=[1,0;0,1];
n=log2(N);
    for i=1:n-1
        Fn=kron(Fn,F);
        Bn=kron(I,Bn);
        Upper=Bn(1:2^i,:);
        Sub=Bn(2^i+1:2^(i+1),:);
        for j=1:2^i
            Bn(2*j-1,:)=Upper(j,1:2^(i+1));
            Bn(2*j,:)=Sub(j,1:2^(i+1));
        end
    end
    Gn=Bn*Fn;
toc;
end

